<!--
This file is part of fm-weck: executing fm-tools in containerized environments.
https://gitlab.com/sosy-lab/software/fm-weck

SPDX-FileCopyrightText: 2024 Dirk Beyer <https://www.sosy-lab.org>

SPDX-License-Identifier: Apache-2.0
-->

# fm-weck - Warp runExec in a container and conserve fm-tools

This project builds on Podman. To develop, you need to install Podman.

## Install dependencies

`fm-weck` requires Python 3.10 or higher. `fm-weck` relies on an available Podman installation. To install Podman on Ubuntu, run the following command:

```
sudo apt install podman
```

## Core principal of the Project

There are three modes of operation: `run`, `shell` and `serve`.

- `run`: executes a single command in the containerized environment of a given verifier, specified through the
corresponding fm-data YAML file
- `shell`: enters an interactive shell inside of the container specified by the given verifier
- `serve`: enables plug-and-play execution of formal methods tools: it 
downloads and unpacks a tool from the fm-tools metadata file into a user-specified cache directory on the host system and then runs the tool in the containerized environment

## Development and Testing

When using any command with the `fm-weck toolname ...` syntax, the tool name is searched in `src/fm_weck/resources/fm_tools`.
During the build process of the `.whl` file for `fm-weck`, the `fm_tools/data` directory is copied to that location.
When running or developing `fm-weck` from the git repository, the user must make sure that the contents of `fm_tools/data` directory are
available in the `src/fm_weck/resources/fm_tools` directory.

In Linux this can be done by running the following command in the root directory of the project:

```
ln -s $(pwd)/fm_tools/data $(pwd)/src/fm_weck/resources/fm_tools
```